
import hpjava.* ;


class Producer extends Thread {
  Port out ;
  int id ;

  public Producer (Port out, int id) {
    this.out  = out ;
    this.id   = id  ;
  }

  public void run() {
    //while(true)
    for(int i = 0 ; i < 25 ; i++)
      out.sendInt(id) ;
  }
}

class Consumer extends Thread {
  Port in1 ;
  Port in2 ;

  public Consumer (Port in1, Port in2) {
    this.in1 = in1 ;
    this.in2 = in2 ;
  }

  public void run() {
    Merge pool = new Merge() ;
    pool.add(in1) ;
    pool.add(in2) ;

    //while(true)
    for(int i = 0 ; i < 50 ; i++)
      System.out.println(pool.select().recvInt()) ;

    //pool.rem(in2) ;
    //pool.rem(in1) ;
  }
}

public class Eg11 {
  public static void main(String args[]) {
    Port P = new Port() ;
    Port Q = new Port() ;

    Port.channel(P, Q) ;

    Port R = new Port() ;
    Port S = new Port() ;

    Port.channel(R, S) ;

    (new Consumer(Q, S)).start() ;

    (new Producer(P, 1)).start() ;
    (new Producer(R, 2)).start() ;
  }
}


